/*

MailSender.js

Copyright (c) 2006 Scue

www.scue.co.uk (www.scue.co.uk/widgets/)
info@scue.co.uk
developer: aidan kane (aidan@scue.co.uk)

see LICENSE for details of the license

*/


// MailSender class to send emails (it fobs the hard work off to Python)

function MailSender()
{
	// type of server to use (gmail, yahoo, etc)
	this.serverType = null;

	// other details of the message
	this.username = null;
	this.password = null;
	this.mailHost = null;
	this.port = null;
	this.useSSL = null;
	this.fromAddress = null;
	this.recipient = null;
	this.subject = null;
	this.message = null;

	// function to call when sending is finished
	this.whenFinished = null;
}


// implementation details
// ----------------------

MailSender.prototype = 
{

	init : function (whenSendFinished)
	{
		this.whenFinished = whenSendFinished;
	},

	sendMessage : function ()
	{
		switch (this.serverType)
		{
			case "gmail" :
				this.mailHost = "smtp.gmail.com";
				this.port = 587;
				this.useSSL = true;
				this.username = this.fromAddress.split("@")[0];
				this.doSend();
				break;

			case "yahoo" :
				this.mailHost = "smtp.mail.yahoo.com";
				this.port = 587;
				this.useSSL = false;
				this.username = this.fromAddress.split("@")[0];
				this.doSend();
				break;

			case "aol" :
				this.mailHost = "smtp.aol.com";
				this.port = 587;
				this.useSSL = true;
				this.username = this.fromAddress.split("@")[0];
				this.doSend();
				break;

			case "aim" :
				this.mailHost = "smtp.aim.com";
				this.port = 587;
				this.useSSL = true;
				this.username = this.fromAddress.split("@")[0];
				this.doSend();
				break;

			case ".mac" :
				this.mailHost = "smtp.mac.com";
				this.port = 587;
				this.useSSL = true;
				this.username = this.fromAddress.split("@")[0];
				this.doSend();
				break;

			case "other" :
				this.doSend();
				break;
		}
	},

	doSend : function ()
	{
		debug('sending message from "'+this.mailHost+'"');

		if (widget)
		{
			var command = widget.system("/usr/bin/python ./scripts/send.py", this.uselessMailSendFinished);
			var localThis = this;
			command.onreadoutput = function (result) { localThis.mailSendFinished(result); };
			command.onreaderror = this.scriptError;

			command.write(this.mailHost+"\r\n");
			command.write(this.port+"\r\n");
			if (this.useSSL)
			{
				command.write("true\r\n");
			} else {
				command.write("false\r\n");
			}
			command.write(this.username+"\r\n");
			command.write(this.password+"\r\n");
			command.write(this.fromAddress+"\r\n");
			command.write(this.recipient+"\r\n");
			command.write(this.subject+"\r\n");
			command.write(this.message+"\r\n");
			command.close();
		}
	},


	scriptError : function(err)
	{
		debug('script error: '+err.toString());
	},

	uselessMailSendFinished : function (result)
	{
		// result doesn't seem to contain anything... not much use
	},

	mailSendFinished : function (result)
	{
		var sendResult = result.toString();		
		var resultLines = sendResult.split("\n");
		resultLines.pop()
		result = (resultLines.pop() == "send ok");

		debug("mSF: send ok - "+result);

		this.whenFinished(result);
	}
}
